Task # 38086 (Closed): Enhance TYPO3 bootstrap mechanism

Status: Resolved Priority: Should have
Author: Christian Kuhn Category:
Created: 2012-06-26 Assigned To:
Updated: 2012-06-30 Due date:
TYPO3 Version: 6.0
PHP Version: 5.3
Complexity: medium
Sprint Focus:
Subject: Move temp_CACHED_* files to caching framework
Description

After the basic bootstrap refactoring that moved the loading of ext_tables.php and
ext_localconf.php to class context, it is now easily possible to put the former
temp_CACHED_* files to the caching framework as cached PHP code, next to the
autoloader registry cache entry.

This patch introduces a new and clean API to t3lib_extMgm to handle the loading
of ext_localconf, ext_tables and the global TYPO3_LOADED_EXT array and removes
the current handling that was cluttered throughout the core.

The setting of TYPO3_CONF_VARS['SYS']['extCache'] is now deprecated and unused.
The bootstrap now decides based on its context, whether or not caching of those
files is used or not. This way we can for example now run the install tool in a
fully uncached environment and can get rid of the nasty side effects we had
in this area in the past.

With a simple call to ext_Mgm::removeCacheFiles() all cache entries in PHP code
cache that are tagged with 'core' can be removed at once. This currently affects
the autoloader registry, the TYPO3_LOADED_EXT entry, and the concatenated
ext_localconf and ext_tables files.

The patch furthermore gets rid of the _CACHEFILE array key in
$GLOBALS['TYPO3_LOADED_EXT'] that worked as a kind of API to the calling method to
indicate if a concatenated ext_tables and ext_localconf file is available.

Related issues:
related to Documentation - Task # 38490: TYPO3 6.0: temp_CACHED_* files have ... New 2012-06-29

Associated revisions
Revision 665a6f79 - 2012-06-28 22:12 - Christian Kuhn

[!!!][TASK] Move temp_CACHED_* files to caching framework

After the basic bootstrap refactoring that moved the loading of
ext_tables.php and ext_localconf.php to class context, it is now easily
possible to put the former temp_CACHED_* files to the caching framework
as cached PHP code, next to the autoloader registry cache entry.

This patch introduces a new API to t3lib_extMgm to handle the
loading of ext_localconf, ext_tables and the global TYPO3_LOADED_EXT
array and removes the current handling that was cluttered throughout
the core.

The setting of TYPO3_CONF_VARS['SYS']['extCache'] is now deprecated and
unused. The bootstrap now decides based on its context, whether caching
of those files is used. This way we can for example run the install tool
in a fully uncached environment and can get rid of the nasty side effects
we had in this area in the past.

With a simple call to t3lib_extMgm::removeCacheFiles() all cache entries
in PHP code cache that are tagged with 'core' can be removed at once.
This currently affects the autoloader registry, the TYPO3_LOADED_EXT
entry, and the concatenated ext_localconf and ext_tables files.

The patch furthermore gets rid of the _CACHEFILE array key in
$GLOBALS['TYPO3_LOADED_EXT'] that worked as a kind of API to the calling
method to indicate if a concatenated ext_tables and ext_localconf file
is available.

Change-Id: Id00be5f24ec1698ed9126e61b229a718d6ca6741
Resolves: #38414
Releases: 6.0
Reviewed-on: http://review.typo3.org/12383
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Susanne Moog
Tested-by: Susanne Moog
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision c9bb9b81 - 2012-07-13 19:56 - Christian Kuhn

[!!!][TASK] Move temp_CACHED_* files to caching framework

After the basic bootstrap refactoring that moved the loading of
ext_tables.php and ext_localconf.php to class context, it is now easily
possible to put the former temp_CACHED_* files to the caching framework
as cached PHP code, next to the autoloader registry cache entry.

This patch introduces a new API to t3lib_extMgm to handle the
loading of ext_localconf, ext_tables and the global TYPO3_LOADED_EXT
array and removes the current handling that was cluttered throughout
the core.

The setting of TYPO3_CONF_VARS['SYS']['extCache'] is now deprecated and
unused. The bootstrap now decides based on its context, whether caching
of those files is used. This way we can for example run the install tool
in a fully uncached environment and can get rid of the nasty side effects
we had in this area in the past.
With a simple call to t3lib_extMgm::removeCacheFiles() all cache entries
in PHP code cache that are tagged with 'core' can be removed at once.
This currently affects the autoloader registry, the TYPO3_LOADED_EXT
entry, and the concatenated ext_localconf and ext_tables files.

The patch furthermore gets rid of the _CACHEFILE array key in
$GLOBALS['TYPO3_LOADED_EXT'] that worked as a kind of API to the calling
method to indicate if a concatenated ext_tables and ext_localconf file
is available.

Change-Id: Id00be5f24ec1698ed9126e61b229a718d6ca6741
Resolves: #38414
Releases: 6.0
Reviewed-on: http://review.typo3.org/12383
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Susanne Moog
Tested-by: Susanne Moog
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History
#1 - 2012-06-26 21:40 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12383

#2 - 2012-06-26 21:48 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12383

#3 - 2012-06-26 21:54 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12383

#4 - 2012-06-27 18:19 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12383

#5 - 2012-06-28 22:30 - Christian Kuhn
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:665a6f7905cd23b24350b011ad385d6604bcab72.

#6 - 2012-06-30 13:24 - Susanne Moog
- Parent task set to #38086
